<!DOCTYPE HTML>
{# ------------------------------------------------------------------------------------ #}
{#  VARIABLES                                                                           #}
{# ------------------------------------------------------------------------------------ #}
{%- set dc = ctx|to_context_obj -%}
{%- import "src/_ifb_dsw_globals.j2" as ifb_dsw_globals with context -%}
{# ------------------------------------------------------------------------------------ #}
{#  TAGS, REFERNCES, and EXPERTS MACROS                                                 #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderTags(question) -%}
  {% if question.tags|length > 0 %}
    <div>
      🏷️ <b>Tags:</b> {% for tag in question.tags %}<i>{{tag.name}}</i>{% if not loop.last %}, {% endif %}{% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderResourcePageReferences(question) -%}
  {% set refs = [] %}
  {% for ref in question.resource_page_references %}
    {% if ref.resource_page_uuid and ref.resource_page and ref.resource_page.collection %}
      {% do refs.append({
        'ref_uuid': ref.uuid,
        'uuid': ref.resource_page_uuid,
        'collection_title': ref.resource_page.collection.title,
        'title': ref.resource_page.title,
      }) %}
    {% endif %}
  {% endfor %}
  {% if refs|length > 0 %}
    <div>
      📖 <b>Resource Pages:</b> {% for ref in refs %}<i>{{ref.collection_title}} - {{ref.title}}</i>{% if not loop.last %}, {% endif %}{% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderURLReferences(question) -%}
  {% set refs = [] %}
  {% for ref in question.url_references %}
    {% if ref.label and ref.url %}
      {% do refs.append({
        'uuid': ref.uuid,
        'label': ref.label,
        'url': ref.url,
      }) %}
    {% endif %}
  {% endfor %}
  {% if refs|length > 0 %}
    <div>
      🔗 <b>External Links:</b> {% for ref in refs %}<a href="{{ref.url}}" target="_blank"><i>{{ref.label}}</i></a>{% if not loop.last %}, {% endif %}{% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderExperts(question) -%}
  {% set experts = [] %}
  {% for expert in question.experts %}
    {% if expert.name and expert.email %}
      {% do experts.append({
        'uuid': expert.uuid,
        'email': expert.email,
        'name': expert.name,
      }) %}
    {% endif %}
  {% endfor %}
  {% if experts|length > 0 %}
    <div>
      🙋 <b>Experts:</b> {% for expert in experts %}<i>{{expert.name}} (<a href="mailto:{{expert.email}}">{{expert.email}}</a>){% if not loop.last %}, {% endif %}</i>{% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  ANSWERS MACROS                                                                      #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderAnswerValue(question, reply, path, humanIdentifier) -%}
  <div>
    <p>
      ✔️
      {% if reply is of_type("StringReply") %}
        <span>{{reply.value}}</span>
      {% else %}
        <span>{{reply.value.rsplit(" ![]")[0]|markdown}}</span>
        {% if reply.is_integration %}
          {# Integration #}
          {% set integration = question.integration %}
          <span>
            ({{ integration.name }}: <a href="{{ integration.item(reply.item_id) }}">{{ reply.item_id }}</a>)
          </span>
        {% endif %}
      {% endif %}
    </p>
  </div>
{%- endmacro -%}
{%- macro renderAnswerOption(globals, question, reply, path, humanIdentifier) -%}

  {%- if reply -%}
    {%- set answer = reply.answer -%}
  {%- else -%}
    {%- set answer = none  -%}
  {%- endif -%}
  
  {%- for option in question.answers -%}
    {% set hi = question.answers.index(option) %}
    {% set path = path ~ "." ~ option.uuid %}
    {% set humanIdentifier = humanIdentifier ~ "." ~ hi|of_alphabet %}
    {%- if reply and option.label == answer.label -%}
      <div>
        <p>
          ✔️ <span>{{ hi|of_alphabet }}. {{answer.label}}</span>
        </p>
        {% if answer.advice and globals.with_all_text %}
          <p>
            <b>Advice:</b> {{answer.advice|markdown}}
          </p>
        {% endif %}
        {% if answer.followups|length > 0 %}
          <div>
            {% set hiPrefix = humanIdentifier ~ "." %}
            {% for question in answer.followups %}
              {% set x = loop.index %}
              {{ renderQuestion(globals, question, path, hiPrefix ~ x) }}
            {% endfor %}
          </div>
        {% endif %}
      </div>
    {% elif not globals.replies_only %}
      <div>
        <p>
          ❌ <span>{{ hi|of_alphabet }}. {{option.label}}</span>
        </p>
        {% if option.advice and globals.with_all_text %}
          <p>
            <b>Advice:</b> {{option.advice|markdown}}
          </p>
        {% endif %}
        {% if option.followups|length > 0 %}
          <div>
            {% set hiPrefix = humanIdentifier ~ "." %}
            {% for question in option.followups %}
              {% set x = loop.index %}
              {{ renderQuestion(globals, question, path, hiPrefix ~ x) }}
            {% endfor %}
          </div>
        {% endif %}
      </div>
    {% endif %}
  {% endfor %}
{%- endmacro -%}
{%- macro renderAnswerList(globals, question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div>
      <h4>Answers ({{reply.items|length}} items)</h4>
      {% set itemPathPrefix = path ~ "." %}
      {% set hiPrefix = humanIdentifier ~ "." %}
      {% for i in reply.items %}
        {% set itemPath = itemPathPrefix ~ i %}
        {% set itemHumanIdenfifier = hiPrefix ~ (loop.index - 1)|of_alphabet %}
        <div class="answer-item" id="{{itemPath}}">
          <div class="followups">
            {% for question in question.followups %}
              {% set x = loop.index %}
              {{ renderQuestion(globals, question, itemPath, itemHumanIdenfifier ~ "." ~ x) }}
            {% endfor %}
          </div>
        </div>
      {% endfor %}
    </div>
  {% elif not globals.replies_only %}
    <div>
      {% set itemPathPrefix = path ~ "." %}
      {% set hiPrefix = humanIdentifier ~ "." %}
      {% set itemUuid = "00000000-0000-0000-0000-000000000000" %}
      {% set itemPath = itemPathPrefix ~ itemUuid %}
      {% set itemHumanIdenfifier = hiPrefix ~ (0)|of_alphabet %}
      <div class="answer-item" id="{{itemPath}}">
        <div class="followups">
          {% for question in question.followups %}
            {% set x = loop.index %}
            {{ renderQuestion(globals, question, itemPath, itemHumanIdenfifier ~ "." ~ x) }}
          {% endfor %}
        </div>
      </div>
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderAnswerChoiceList(globals, question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div>
      <ul>
        {% for choice in question.choices %}
          {%- if choice in reply.choices %}
            <li>✔️ {{ choice.label }}</li>
          {%- else %}
            <li>❌ {{ choice.label }}</li>
          {%- endif %}
        {% endfor %}
      </ul>
    </div>
  {% elif not globals.replies_only %}
    <div>
      <ul>
        {% for choice in question.choices %}
          <li>❌ {{ choice.label }}</li>
        {% endfor %}
      </ul>
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderAnswerItemSelect(question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div>
      <p>✔️ {{ reply.item_title }}</p>
    </div>
  {% endif %}
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  QUESTION MACROS                                                                     #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderQuestionExtras(question) -%}
  <div>
    {{ renderResourcePageReferences(question) }}
    {{ renderURLReferences(question) }}
    {{ renderExperts(question) }}
  </div>
{%- endmacro -%}
{%- macro renderQuestionReply(globals, question, path, humanIdentifier) -%}
  {# Question - Answers #}
  {% set reply = question.replies.get(path) %}
  {% if reply and reply.value and (globals.with_replies or globals.replies_only) %}
    {% if question is of_type("ValueQuestion") and reply is of_type("StringReply") %}
      {{ renderAnswerValue(question, reply, path, humanIdentifier) }}
    {% elif question is of_type("OptionsQuestion") and reply is of_type("AnswerReply") %}
      {{ renderAnswerOption(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("ListQuestion") and reply is of_type("ItemListReply") %}
      {{ renderAnswerList(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("IntegrationQuestion") and reply is of_type("IntegrationReply") %}
      {{ renderAnswerValue(question, reply, path, humanIdentifier) }}
    {% elif question is of_type("MultiChoiceQuestion") and reply is of_type("MultiChoiceReply") %}
      {{ renderAnswerChoiceList(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("ItemSelectQuestion") and reply is of_type("ItemSelectReply") %}
      {{ renderAnswerItemSelect(question, reply, path, humanIdentifier) }}
    {% endif %}
  {% elif not globals.replies_only %}
    {% if question is of_type("OptionsQuestion") %}
      {{ renderAnswerOption(globals, question, none, path, humanIdentifier) }}
    {% elif question is of_type("ListQuestion") %}
      {{ renderAnswerList(globals, question, none, path, humanIdentifier) }}
    {% elif question is of_type("MultiChoiceQuestion") %}
      {{ renderAnswerChoiceList(globals, question, none, path, humanIdentifier) }}
    {% endif %}
  {% endif %}
{%- endmacro -%}
{%- macro renderQuestion(globals, question, path, humanIdentifier) -%}
  {% set path = path ~ "." ~ question.uuid %}
  <div>
    <h2>{{humanIdentifier}}. {{question.title}}</h2>

 {#   {{ renderTags(question) }} #}

    {% if globals.with_all_text %}
      {{ question.text|markdown }} 
      {{ renderQuestionExtras(question) }}
    {% endif %}
    
    {{ renderQuestionReply(globals, question, path, humanIdentifier) }} 
  </div>
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  CHAPTER MACROS                                                                      #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderChapter(globals, chapter, humanIdentifier) -%}
  <section>
    <h1>{{humanIdentifier|roman}}. {{chapter.title}}</h1>
    {% if globals.with_all_text %}
      <p>{{chapter.text|markdown}}</p> 
    {% endif %}
    
    <section>
      {% for question in chapter.questions %}
        {{ renderQuestion(globals, question, chapter.uuid, loop.index) }}
      {% endfor %}
    </section>
  </section>
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  HTML LAYOUT                                                                         #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderReport(report) -%}
  <section>
    <h2>Summary</h2>
    <h3>Answered indication</h3>
    <table>
      <tbody>
        {% for item in report.indications %}
          <tr>
            <td>Answered {% if item.is_for_phase %}(current phase){% endif %}</td>
              <td>{{item.answered}} / {{item.total}} </td>
            <td>{{ "%.2f"|format(item.percentage)}} %</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
    {% if report.metrics|length > 0 %}
    <h3>Metrics</h3>
    <table>
      <thead><tr><th>Metric</th><th>Score</th></tr></thead>
      <tbody>
        {% for item in report.metrics %}
          <tr>
            <td>{{ item.metric.title }}</td>
            <td>{{ "%.2f"|format(item.measure) }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
    {% endif %}
  </section>
{%- endmacro -%}
{%- macro renderFrontPage() -%}
  <table>
    <tr>
      <th>Organization</th>
      <td>{{dc.org.name}}</td>
    </tr>
    {% if dc.qtn.created_by %}
    <tr>
      <th>Created by</th>
      <td>{{dc.qtn.created_by.first_name}} {{dc.qtn.created_by.last_name}} (<a href="mailto:{{dc.qtn.created_by.email}}">{{dc.qtn.created_by.email}}</a>)</td>
    </tr>
    {% endif %}
    <tr>
      <th>Based on</th>
      <td>{{dc.pkg.name}}, {{dc.pkg.version}} (<code>{{dc.pkg.org_id}}:{{dc.pkg.km_id}}:{{dc.pkg.version}}</code>)</td>
    </tr>
    {% for version in dc.qtn.versions if version.uuid == dc.qtn.version %}
    <tr>
      <th>Version</th>
      <td>{{version.name}} ({{ version.created_at|datetime_format("%d %b %Y %H:%M:%S") }} UTC)</td>
    </tr>
    {% endfor %}
    {% if dc.current_phase %}
    <tr>
      <th>Project Phase</th>
      <td>{{dc.current_phase.title}}</td>
    </tr>
    {% endif %}
    {% if dc.qtn.project_tags|length > 0 %}
    <tr>
      <th>Project Tags</th>
      <td class="tags-row">{% for tag in dc.qtn.project_tags %}<span class="tag project-tag">{{ tag }}</span> {% endfor %}</td>
    </tr>
    {% endif %}
    {% if dc.qtn.description %}
    <tr>
      <th>Description</th>
      <td>{{ dc.qtn.description }}</td>
    </tr>
    {% endif %}
    <tr>
      <th>Created at</th>
      <td>{{ dc.doc.created_at|datetime_format("%d %b %Y") }}</td>
    </tr>
  </table>

  \newpage
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  HTML TEMPLATE                                                                       #}
{# ------------------------------------------------------------------------------------ #}



{# here I'll move all original macros from DSW Questionnaire Report #}
{# that are not used in the context of IFB-lite #}
{# I keep them here just in case they might become handy #}
{# ------------------------------------------------------------------------------------ #}
{#  HTML TEMPLATE                                                                       #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderResourceCollection(collection, humanIdentifier) -%}
  <div>
    <h3>{{ humanIdentifier }}. {{ collection.title }}</h3>

    {%- for page in collection.pages -%}
    <div>
      <h4>{{ humanIdentifier }}.{{ loop.index }}. {{ page.title }}</h4>
      <div>
        {{ page.content|markdown }}
      </div>
    </div>
    {%- endfor -%}
  </div>
{%- endmacro -%}
{#
<html>
  <head>
    <title>{{dc.qtn.name}}</title>
    <meta charset="utf-8">
  </head>
  <body>
      {{ renderFrontPage() }}
      {{ renderContent() }}
  </body>
</html>
#}
{%- macro renderContent() -%}
  <div>
    <div>
      {{ renderReport(dc.report.total_report) }}
    </div>
    {% if dc.qtn.versions|length > 0 %}
      {{ renderVersionsOverview() }}
    {% endif %}
    {% for chapter in dc.km.chapters %}
      \newpage
      {{ renderChapter(chapter, loop.index) }}
    {% else %}
      <p><i>No chapters</i></p>
    {% endfor %}

    <section>
    {% if dc.km.resource_collections|length > 0 %}
      <h2>Additional Resources</h2>
    {% endif %}
    {% for resource_collection in dc.km.resource_collections %}
      {{ renderResourceCollection(resource_collection, (loop.index-1)|of_alphabet|upper) }}
    {% endfor %}
    </section>
  </div>
{%- endmacro -%}
{%- macro renderVersionsOverview() -%}
  <div>
    <h2>History of Versions</h2>
    <p>The named versions of this document:</p>
    <ul>
      {% for version in dc.qtn.versions|reverse %}
        <li>
          <strong>{{ version.name }}</strong> ({{ version.created_at|datetime_format("%d %b %Y") }})
          <p>{{ version.description }}</p>
        </li>
      {% endfor %}
    </ul>
  </div>
{%- endmacro -%}
